diff -ur ncurses-5.9-orig/menu/m_new.c ncurses-5.9/menu/m_new.c
--- ncurses-5.9-orig/menu/m_new.c	2010-01-23 16:20:11 -0500
+++ ncurses-5.9/menu/m_new.c	2013-07-04 18:38:38 -0400
@@ -50,7 +50,7 @@
 |
 |   Return Values :  NULL on error
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(MENU *)
+NCMENU_EXPORT(MENU *)
 NCURSES_SP_NAME(new_menu) (NCURSES_SP_DCLx ITEM ** items)
 {
   int err = E_SYSTEM_ERROR;
@@ -101,7 +101,7 @@
 |   Return Values :  NULL on error
 +--------------------------------------------------------------------------*/
 #if NCURSES_SP_FUNCS
-NCURSES_EXPORT(MENU *)
+NCMENU_EXPORT(MENU *)
 new_menu(ITEM ** items)
 {
   return NCURSES_SP_NAME(new_menu) (CURRENT_SCREEN, items);
@@ -119,7 +119,7 @@
 |                    E_BAD_ARGUMENT     - Invalid menu pointer passed
 |                    E_POSTED           - Menu is already posted
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(int)
+NCMENU_EXPORT(int)
 free_menu(MENU * menu)
 {
   T((T_CALLED("free_menu(%p)"), (void *)menu));
diff -ur ncurses-5.9-orig/menu/m_opts.c ncurses-5.9/menu/m_opts.c
--- ncurses-5.9-orig/menu/m_opts.c	2010-01-23 16:20:10 -0500
+++ ncurses-5.9/menu/m_opts.c	2013-07-04 18:38:38 -0400
@@ -52,7 +52,7 @@
 |                    E_BAD_ARGUMENT - invalid menu options
 |                    E_POSTED       - menu is already posted
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(int)
+NCMENU_EXPORT(int)
 set_menu_opts(MENU * menu, Menu_Options opts)
 {
   T((T_CALLED("set_menu_opts(%p,%d)"), (void *)menu, opts));
@@ -112,7 +112,7 @@
 |                    E_BAD_ARGUMENT - invalid options
 |                    E_POSTED       - menu is already posted
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(int)
+NCMENU_EXPORT(int)
 menu_opts_off(MENU * menu, Menu_Options opts)
 {
   MENU *cmenu = menu;		/* use a copy because set_menu_opts must detect
@@ -145,7 +145,7 @@
 |                    E_BAD_ARGUMENT - invalid menu options
 |                    E_POSTED       - menu is already posted
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(int)
+NCMENU_EXPORT(int)
 menu_opts_on(MENU * menu, Menu_Options opts)
 {
   MENU *cmenu = menu;		/* use a copy because set_menu_opts must detect
@@ -173,7 +173,7 @@
 |
 |   Return Values :  Menu options
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(Menu_Options)
+NCMENU_EXPORT(Menu_Options)
 menu_opts(const MENU * menu)
 {
   T((T_CALLED("menu_opts(%p)"), (const void *)menu));
diff -ur ncurses-5.9-orig/menu/m_pad.c ncurses-5.9/menu/m_pad.c
--- ncurses-5.9-orig/menu/m_pad.c	2010-01-23 16:20:10 -0500
+++ ncurses-5.9/menu/m_pad.c	2013-07-04 18:38:38 -0400
@@ -58,7 +58,7 @@
 |   Return Values :  E_OK              - success
 |                    E_BAD_ARGUMENT    - an invalid value has been passed
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(int)
+NCMENU_EXPORT(int)
 set_menu_pad(MENU * menu, int pad)
 {
   bool do_refresh = (menu != (MENU *) 0);
@@ -85,7 +85,7 @@
 |
 |   Return Values :  The pad character
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(int)
+NCMENU_EXPORT(int)
 menu_pad(const MENU * menu)
 {
   T((T_CALLED("menu_pad(%p)"), (const void *)menu));
diff -ur ncurses-5.9-orig/menu/m_pattern.c ncurses-5.9/menu/m_pattern.c
--- ncurses-5.9-orig/menu/m_pattern.c	2010-01-23 16:20:10 -0500
+++ ncurses-5.9/menu/m_pattern.c	2013-07-04 18:38:38 -0400
@@ -50,7 +50,7 @@
 |                                    pattern is stored
 |                    PatternString - as expected
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(char *)
+NCMENU_EXPORT(char *)
 menu_pattern(const MENU * menu)
 {
   static char empty[] = "";
@@ -72,7 +72,7 @@
 |                    E_NOT_CONNECTED   - no items connected to menu
 |                    E_NO_MATCH        - no item matches pattern
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(int)
+NCMENU_EXPORT(int)
 set_menu_pattern(MENU * menu, const char *p)
 {
   ITEM *matchitem;
diff -ur ncurses-5.9-orig/menu/m_post.c ncurses-5.9/menu/m_post.c
--- ncurses-5.9-orig/menu/m_post.c	2010-05-01 15:18:27 -0400
+++ ncurses-5.9/menu/m_post.c	2013-07-04 18:38:38 -0400
@@ -48,7 +48,7 @@
 |
 |   Return Values :  -
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(void)
+NCMENU_EXPORT(void)
 _nc_Post_Item(const MENU * menu, const ITEM * item)
 {
   int i;
@@ -196,7 +196,7 @@
 |
 |   Return Values :  -
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(void)
+NCMENU_EXPORT(void)
 _nc_Draw_Menu(const MENU * menu)
 {
   ITEM *item = menu->items[0];
@@ -266,7 +266,7 @@
 |                    E_BAD_STATE         - Menu in userexit routine
 |                    E_POSTED            - Menu already posted
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(int)
+NCMENU_EXPORT(int)
 post_menu(MENU * menu)
 {
   T((T_CALLED("post_menu(%p)"), (void *)menu));
@@ -338,7 +338,7 @@
 |                    E_BAD_STATE       - menu in userexit routine
 |                    E_NOT_POSTED      - menu is not posted
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(int)
+NCMENU_EXPORT(int)
 unpost_menu(MENU * menu)
 {
   WINDOW *win;
diff -ur ncurses-5.9-orig/menu/m_req_name.c ncurses-5.9/menu/m_req_name.c
--- ncurses-5.9-orig/menu/m_req_name.c	2009-10-10 12:17:23 -0400
+++ ncurses-5.9/menu/m_req_name.c	2013-07-04 18:38:38 -0400
@@ -71,7 +71,7 @@
 |   Return Values :  Pointer to name      - on success
 |                    NULL                 - on invalid request code
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(const char *)
+NCMENU_EXPORT(const char *)
 menu_request_name(int request)
 {
   T((T_CALLED("menu_request_name(%d)"), request));
@@ -93,7 +93,7 @@
 |   Return Values :  Request Id       - on success
 |                    E_NO_MATCH       - request not found
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(int)
+NCMENU_EXPORT(int)
 menu_request_by_name(const char *str)
 {
   /* because the table is so small, it doesn't really hurt
diff -ur ncurses-5.9-orig/menu/m_scale.c ncurses-5.9/menu/m_scale.c
--- ncurses-5.9-orig/menu/m_scale.c	2010-01-23 16:20:10 -0500
+++ ncurses-5.9/menu/m_scale.c	2013-07-04 18:38:38 -0400
@@ -50,7 +50,7 @@
 |                    E_BAD_ARGUMENT        - invalid menu pointer
 |                    E_NOT_CONNECTED       - no items are connected to menu
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(int)
+NCMENU_EXPORT(int)
 scale_menu(const MENU * menu, int *rows, int *cols)
 {
   T((T_CALLED("scale_menu(%p,%p,%p)"),
diff -ur ncurses-5.9-orig/menu/m_spacing.c ncurses-5.9/menu/m_spacing.c
--- ncurses-5.9-orig/menu/m_spacing.c	2010-01-23 16:20:10 -0500
+++ ncurses-5.9/menu/m_spacing.c	2013-07-04 18:38:38 -0400
@@ -51,7 +51,7 @@
 |
 |   Return Values :  E_OK                 - on success
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(int)
+NCMENU_EXPORT(int)
 set_menu_spacing(MENU * menu, int s_desc, int s_row, int s_col)
 {
   MENU *m;			/* split for ATAC workaround */
@@ -86,7 +86,7 @@
 |
 |   Return Values :  E_OK             - on success
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(int)
+NCMENU_EXPORT(int)
 menu_spacing(const MENU * menu, int *s_desc, int *s_row, int *s_col)
 {
   const MENU *m;		/* split for ATAC workaround */
diff -ur ncurses-5.9-orig/menu/m_sub.c ncurses-5.9/menu/m_sub.c
--- ncurses-5.9-orig/menu/m_sub.c	2010-01-23 16:20:11 -0500
+++ ncurses-5.9/menu/m_sub.c	2013-07-04 18:38:38 -0400
@@ -48,7 +48,7 @@
 |   Return Values :  E_OK           - success
 |                    E_POSTED       - menu is already posted
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(int)
+NCMENU_EXPORT(int)
 set_menu_sub(MENU * menu, WINDOW *win)
 {
   T((T_CALLED("set_menu_sub(%p,%p)"), (void *)menu, (void *)win));
@@ -88,7 +88,7 @@
 |
 |   Return Values :  NULL on error, otherwise a pointer to the window
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(WINDOW *)
+NCMENU_EXPORT(WINDOW *)
 menu_sub(const MENU * menu)
 {
   const MENU *m = Normalize_Menu(menu);
diff -ur ncurses-5.9-orig/menu/m_trace.c ncurses-5.9/menu/m_trace.c
--- ncurses-5.9-orig/menu/m_trace.c	2010-01-23 16:20:10 -0500
+++ ncurses-5.9/menu/m_trace.c	2013-07-04 18:38:38 -0400
@@ -34,42 +34,42 @@
 
 MODULE_ID("$Id: m_trace.c,v 1.4 2010/01/23 21:20:10 tom Exp $")
 
-NCURSES_EXPORT(ITEM *)
+NCMENU_EXPORT(ITEM *)
 _nc_retrace_item(ITEM * code)
 {
   T((T_RETURN("%p"), (void *)code));
   return code;
 }
 
-NCURSES_EXPORT(ITEM **)
+NCMENU_EXPORT(ITEM **)
 _nc_retrace_item_ptr(ITEM ** code)
 {
   T((T_RETURN("%p"), (void *)code));
   return code;
 }
 
-NCURSES_EXPORT(Item_Options)
+NCMENU_EXPORT(Item_Options)
 _nc_retrace_item_opts(Item_Options code)
 {
   T((T_RETURN("%d"), code));
   return code;
 }
 
-NCURSES_EXPORT(MENU *)
+NCMENU_EXPORT(MENU *)
 _nc_retrace_menu(MENU * code)
 {
   T((T_RETURN("%p"), (void *)code));
   return code;
 }
 
-NCURSES_EXPORT(Menu_Hook)
+NCMENU_EXPORT(Menu_Hook)
 _nc_retrace_menu_hook(Menu_Hook code)
 {
   T((T_RETURN("%p"), code));
   return code;
 }
 
-NCURSES_EXPORT(Menu_Options)
+NCMENU_EXPORT(Menu_Options)
 _nc_retrace_menu_opts(Menu_Options code)
 {
   T((T_RETURN("%d"), code));
diff -ur ncurses-5.9-orig/menu/m_userptr.c ncurses-5.9/menu/m_userptr.c
--- ncurses-5.9-orig/menu/m_userptr.c	2010-01-23 16:20:10 -0500
+++ ncurses-5.9/menu/m_userptr.c	2013-07-04 18:38:38 -0400
@@ -48,7 +48,7 @@
 |
 |   Return Values :  E_OK         - success
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(int)
+NCMENU_EXPORT(int)
 set_menu_userptr(MENU * menu, void *userptr)
 {
   T((T_CALLED("set_menu_userptr(%p,%p)"), (void *)menu, (void *)userptr));
@@ -66,7 +66,7 @@
 |   Return Values :  Value of the pointer. If no such pointer has been set,
 |                    NULL is returned
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(void *)
+NCMENU_EXPORT(void *)
 menu_userptr(const MENU * menu)
 {
   T((T_CALLED("menu_userptr(%p)"), (const void *)menu));
diff -ur ncurses-5.9-orig/menu/m_win.c ncurses-5.9/menu/m_win.c
--- ncurses-5.9-orig/menu/m_win.c	2010-01-23 16:20:11 -0500
+++ ncurses-5.9/menu/m_win.c	2013-07-04 18:38:38 -0400
@@ -48,7 +48,7 @@
 |   Return Values :  E_OK               - success
 |                    E_POSTED           - menu is already posted
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(int)
+NCMENU_EXPORT(int)
 set_menu_win(MENU * menu, WINDOW *win)
 {
   T((T_CALLED("set_menu_win(%p,%p)"), (void *)menu, (void *)win));
@@ -88,7 +88,7 @@
 |
 |   Return Values :  NULL on error, otherwise pointer to window
 +--------------------------------------------------------------------------*/
-NCURSES_EXPORT(WINDOW *)
+NCMENU_EXPORT(WINDOW *)
 menu_win(const MENU * menu)
 {
   const MENU *m = Normalize_Menu(menu);
diff -ur ncurses-5.9-orig/menu/menu.h ncurses-5.9/menu/menu.h
--- ncurses-5.9-orig/menu/menu.h	2009-04-04 20:28:07 -0400
+++ ncurses-5.9/menu/menu.h	2013-07-04 18:38:38 -0400
@@ -172,85 +172,85 @@
 
 /* --------- prototypes for libmenu functions ----------------------------- */
 
-extern NCURSES_EXPORT(ITEM **)	menu_items (const MENU *);
-extern NCURSES_EXPORT(ITEM *)	current_item (const MENU *);
-extern NCURSES_EXPORT(ITEM *)	new_item (const char *,const char *);
-
-extern NCURSES_EXPORT(MENU *)	new_menu (ITEM **);
-
-extern NCURSES_EXPORT(Item_Options)	item_opts (const ITEM *);
-extern NCURSES_EXPORT(Menu_Options)	menu_opts (const MENU *);
-
-extern NCURSES_EXPORT(Menu_Hook)	item_init (const MENU *);
-extern NCURSES_EXPORT(Menu_Hook)	item_term (const MENU *);
-extern NCURSES_EXPORT(Menu_Hook)	menu_init (const MENU *);
-extern NCURSES_EXPORT(Menu_Hook)	menu_term (const MENU *);
-
-extern NCURSES_EXPORT(WINDOW *)	menu_sub (const MENU *);
-extern NCURSES_EXPORT(WINDOW *)	menu_win (const MENU *);
-
-extern NCURSES_EXPORT(const char *)	item_description (const ITEM *);
-extern NCURSES_EXPORT(const char *)	item_name (const ITEM *);
-extern NCURSES_EXPORT(const char *)	menu_mark (const MENU *);
-extern NCURSES_EXPORT(const char *)	menu_request_name (int);
-
-extern NCURSES_EXPORT(char *)	menu_pattern (const MENU *);
-
-extern NCURSES_EXPORT(void *)	menu_userptr (const MENU *);
-extern NCURSES_EXPORT(void *)	item_userptr (const ITEM *);
-
-extern NCURSES_EXPORT(chtype)	menu_back (const MENU *);
-extern NCURSES_EXPORT(chtype)	menu_fore (const MENU *);
-extern NCURSES_EXPORT(chtype)	menu_grey (const MENU *);
-
-extern NCURSES_EXPORT(int)	free_item (ITEM *);
-extern NCURSES_EXPORT(int)	free_menu (MENU *);
-extern NCURSES_EXPORT(int)	item_count (const MENU *);
-extern NCURSES_EXPORT(int)	item_index (const ITEM *);
-extern NCURSES_EXPORT(int)	item_opts_off (ITEM *,Item_Options);
-extern NCURSES_EXPORT(int)	item_opts_on (ITEM *,Item_Options);
-extern NCURSES_EXPORT(int)	menu_driver (MENU *,int);
-extern NCURSES_EXPORT(int)	menu_opts_off (MENU *,Menu_Options);
-extern NCURSES_EXPORT(int)	menu_opts_on (MENU *,Menu_Options);
-extern NCURSES_EXPORT(int)	menu_pad (const MENU *);
-extern NCURSES_EXPORT(int)	pos_menu_cursor (const MENU *);
-extern NCURSES_EXPORT(int)	post_menu (MENU *);
-extern NCURSES_EXPORT(int)	scale_menu (const MENU *,int *,int *);
-extern NCURSES_EXPORT(int)	set_current_item (MENU *menu,ITEM *item);
-extern NCURSES_EXPORT(int)	set_item_init (MENU *, Menu_Hook);
-extern NCURSES_EXPORT(int)	set_item_opts (ITEM *,Item_Options);
-extern NCURSES_EXPORT(int)	set_item_term (MENU *, Menu_Hook);
-extern NCURSES_EXPORT(int)	set_item_userptr (ITEM *, void *);
-extern NCURSES_EXPORT(int)	set_item_value (ITEM *,bool);
-extern NCURSES_EXPORT(int)	set_menu_back (MENU *,chtype);
-extern NCURSES_EXPORT(int)	set_menu_fore (MENU *,chtype);
-extern NCURSES_EXPORT(int)	set_menu_format (MENU *,int,int);
-extern NCURSES_EXPORT(int)	set_menu_grey (MENU *,chtype);
-extern NCURSES_EXPORT(int)	set_menu_init (MENU *, Menu_Hook);
-extern NCURSES_EXPORT(int)	set_menu_items (MENU *,ITEM **);
-extern NCURSES_EXPORT(int)	set_menu_mark (MENU *, const char *);
-extern NCURSES_EXPORT(int)	set_menu_opts (MENU *,Menu_Options);
-extern NCURSES_EXPORT(int)	set_menu_pad (MENU *,int);
-extern NCURSES_EXPORT(int)	set_menu_pattern (MENU *,const char *);
-extern NCURSES_EXPORT(int)	set_menu_sub (MENU *,WINDOW *);
-extern NCURSES_EXPORT(int)	set_menu_term (MENU *, Menu_Hook);
-extern NCURSES_EXPORT(int)	set_menu_userptr (MENU *,void *);
-extern NCURSES_EXPORT(int)	set_menu_win (MENU *,WINDOW *);
-extern NCURSES_EXPORT(int)	set_top_row (MENU *,int);
-extern NCURSES_EXPORT(int)	top_row (const MENU *);
-extern NCURSES_EXPORT(int)	unpost_menu (MENU *);
-extern NCURSES_EXPORT(int)	menu_request_by_name (const char *);
-extern NCURSES_EXPORT(int)	set_menu_spacing (MENU *,int,int,int);
-extern NCURSES_EXPORT(int)	menu_spacing (const MENU *,int *,int *,int *);
+extern NCMENU_EXPORT(ITEM **)	menu_items (const MENU *);
+extern NCMENU_EXPORT(ITEM *)	current_item (const MENU *);
+extern NCMENU_EXPORT(ITEM *)	new_item (const char *,const char *);
+
+extern NCMENU_EXPORT(MENU *)	new_menu (ITEM **);
+
+extern NCMENU_EXPORT(Item_Options)	item_opts (const ITEM *);
+extern NCMENU_EXPORT(Menu_Options)	menu_opts (const MENU *);
+
+extern NCMENU_EXPORT(Menu_Hook)	item_init (const MENU *);
+extern NCMENU_EXPORT(Menu_Hook)	item_term (const MENU *);
+extern NCMENU_EXPORT(Menu_Hook)	menu_init (const MENU *);
+extern NCMENU_EXPORT(Menu_Hook)	menu_term (const MENU *);
+
+extern NCMENU_EXPORT(WINDOW *)	menu_sub (const MENU *);
+extern NCMENU_EXPORT(WINDOW *)	menu_win (const MENU *);
+
+extern NCMENU_EXPORT(const char *)	item_description (const ITEM *);
+extern NCMENU_EXPORT(const char *)	item_name (const ITEM *);
+extern NCMENU_EXPORT(const char *)	menu_mark (const MENU *);
+extern NCMENU_EXPORT(const char *)	menu_request_name (int);
+
+extern NCMENU_EXPORT(char *)	menu_pattern (const MENU *);
+
+extern NCMENU_EXPORT(void *)	menu_userptr (const MENU *);
+extern NCMENU_EXPORT(void *)	item_userptr (const ITEM *);
+
+extern NCMENU_EXPORT(chtype)	menu_back (const MENU *);
+extern NCMENU_EXPORT(chtype)	menu_fore (const MENU *);
+extern NCMENU_EXPORT(chtype)	menu_grey (const MENU *);
+
+extern NCMENU_EXPORT(int)	free_item (ITEM *);
+extern NCMENU_EXPORT(int)	free_menu (MENU *);
+extern NCMENU_EXPORT(int)	item_count (const MENU *);
+extern NCMENU_EXPORT(int)	item_index (const ITEM *);
+extern NCMENU_EXPORT(int)	item_opts_off (ITEM *,Item_Options);
+extern NCMENU_EXPORT(int)	item_opts_on (ITEM *,Item_Options);
+extern NCMENU_EXPORT(int)	menu_driver (MENU *,int);
+extern NCMENU_EXPORT(int)	menu_opts_off (MENU *,Menu_Options);
+extern NCMENU_EXPORT(int)	menu_opts_on (MENU *,Menu_Options);
+extern NCMENU_EXPORT(int)	menu_pad (const MENU *);
+extern NCMENU_EXPORT(int)	pos_menu_cursor (const MENU *);
+extern NCMENU_EXPORT(int)	post_menu (MENU *);
+extern NCMENU_EXPORT(int)	scale_menu (const MENU *,int *,int *);
+extern NCMENU_EXPORT(int)	set_current_item (MENU *menu,ITEM *item);
+extern NCMENU_EXPORT(int)	set_item_init (MENU *, Menu_Hook);
+extern NCMENU_EXPORT(int)	set_item_opts (ITEM *,Item_Options);
+extern NCMENU_EXPORT(int)	set_item_term (MENU *, Menu_Hook);
+extern NCMENU_EXPORT(int)	set_item_userptr (ITEM *, void *);
+extern NCMENU_EXPORT(int)	set_item_value (ITEM *,bool);
+extern NCMENU_EXPORT(int)	set_menu_back (MENU *,chtype);
+extern NCMENU_EXPORT(int)	set_menu_fore (MENU *,chtype);
+extern NCMENU_EXPORT(int)	set_menu_format (MENU *,int,int);
+extern NCMENU_EXPORT(int)	set_menu_grey (MENU *,chtype);
+extern NCMENU_EXPORT(int)	set_menu_init (MENU *, Menu_Hook);
+extern NCMENU_EXPORT(int)	set_menu_items (MENU *,ITEM **);
+extern NCMENU_EXPORT(int)	set_menu_mark (MENU *, const char *);
+extern NCMENU_EXPORT(int)	set_menu_opts (MENU *,Menu_Options);
+extern NCMENU_EXPORT(int)	set_menu_pad (MENU *,int);
+extern NCMENU_EXPORT(int)	set_menu_pattern (MENU *,const char *);
+extern NCMENU_EXPORT(int)	set_menu_sub (MENU *,WINDOW *);
+extern NCMENU_EXPORT(int)	set_menu_term (MENU *, Menu_Hook);
+extern NCMENU_EXPORT(int)	set_menu_userptr (MENU *,void *);
+extern NCMENU_EXPORT(int)	set_menu_win (MENU *,WINDOW *);
+extern NCMENU_EXPORT(int)	set_top_row (MENU *,int);
+extern NCMENU_EXPORT(int)	top_row (const MENU *);
+extern NCMENU_EXPORT(int)	unpost_menu (MENU *);
+extern NCMENU_EXPORT(int)	menu_request_by_name (const char *);
+extern NCMENU_EXPORT(int)	set_menu_spacing (MENU *,int,int,int);
+extern NCMENU_EXPORT(int)	menu_spacing (const MENU *,int *,int *,int *);
 
 
-extern NCURSES_EXPORT(bool)	item_value (const ITEM *);
-extern NCURSES_EXPORT(bool)	item_visible (const ITEM *);
+extern NCMENU_EXPORT(bool)	item_value (const ITEM *);
+extern NCMENU_EXPORT(bool)	item_visible (const ITEM *);
 
-extern NCURSES_EXPORT(void)	menu_format (const MENU *,int *,int *);
+extern NCMENU_EXPORT(void)	menu_format (const MENU *,int *,int *);
 
 #if NCURSES_SP_FUNCS
-extern NCURSES_EXPORT(MENU *)	NCURSES_SP_NAME(new_menu) (SCREEN*, ITEM **);
+extern NCMENU_EXPORT(MENU *)	NCURSES_SP_NAME(new_menu) (SCREEN*, ITEM **);
 #endif
 
 #ifdef __cplusplus
diff -ur ncurses-5.9-orig/menu/menu.priv.h ncurses-5.9/menu/menu.priv.h
--- ncurses-5.9-orig/menu/menu.priv.h	2009-02-28 16:02:57 -0500
+++ ncurses-5.9/menu/menu.priv.h	2013-07-04 18:38:38 -0400
@@ -47,8 +47,8 @@
 /* Backspace code */
 #define BS (8)
 
-extern NCURSES_EXPORT_VAR(ITEM) _nc_Default_Item;
-extern NCURSES_EXPORT_VAR(MENU) _nc_Default_Menu;
+extern NCMENU_EXPORT_VAR(ITEM) _nc_Default_Item;
+extern NCMENU_EXPORT_VAR(MENU) _nc_Default_Menu;
 
 /* Normalize item to default if none was given */
 #define Normalize_Item( item ) ((item)=(item)?(item):&_nc_Default_Item)
@@ -113,17 +113,17 @@
 #define UChar(c)	((unsigned char)(c))
 
 /* Internal functions. */
-extern NCURSES_EXPORT(void) _nc_Draw_Menu (const MENU *);
-extern NCURSES_EXPORT(void) _nc_Show_Menu (const MENU *);
-extern NCURSES_EXPORT(void) _nc_Calculate_Item_Length_and_Width (MENU *);
-extern NCURSES_EXPORT(int)  _nc_Calculate_Text_Width(const TEXT *);
-extern NCURSES_EXPORT(void) _nc_Post_Item (const MENU *, const ITEM *);
-extern NCURSES_EXPORT(bool) _nc_Connect_Items (MENU *, ITEM **);
-extern NCURSES_EXPORT(void) _nc_Disconnect_Items (MENU *);
-extern NCURSES_EXPORT(void) _nc_New_TopRow_and_CurrentItem (MENU *,int, ITEM *);
-extern NCURSES_EXPORT(void) _nc_Link_Items (MENU *);
-extern NCURSES_EXPORT(int)  _nc_Match_Next_Character_In_Item_Name (MENU*,int,ITEM**);
-extern NCURSES_EXPORT(int)  _nc_menu_cursor_pos (const MENU* menu, const ITEM* item,
+extern NCMENU_EXPORT(void) _nc_Draw_Menu (const MENU *);
+extern NCMENU_EXPORT(void) _nc_Show_Menu (const MENU *);
+extern NCMENU_EXPORT(void) _nc_Calculate_Item_Length_and_Width (MENU *);
+extern NCMENU_EXPORT(int)  _nc_Calculate_Text_Width(const TEXT *);
+extern NCMENU_EXPORT(void) _nc_Post_Item (const MENU *, const ITEM *);
+extern NCMENU_EXPORT(bool) _nc_Connect_Items (MENU *, ITEM **);
+extern NCMENU_EXPORT(void) _nc_Disconnect_Items (MENU *);
+extern NCMENU_EXPORT(void) _nc_New_TopRow_and_CurrentItem (MENU *,int, ITEM *);
+extern NCMENU_EXPORT(void) _nc_Link_Items (MENU *);
+extern NCMENU_EXPORT(int)  _nc_Match_Next_Character_In_Item_Name (MENU*,int,ITEM**);
+extern NCMENU_EXPORT(int)  _nc_menu_cursor_pos (const MENU* menu, const ITEM* item,
 				int* pY, int* pX);
 
 #ifdef TRACE
@@ -135,12 +135,12 @@
 #define returnMenuHook(code)	TRACE_RETURN(code,menu_hook)
 #define returnMenuOpts(code)	TRACE_RETURN(code,menu_opts)
 
-extern NCURSES_EXPORT(ITEM *)	    _nc_retrace_item (ITEM *);
-extern NCURSES_EXPORT(ITEM **)	    _nc_retrace_item_ptr (ITEM **);
-extern NCURSES_EXPORT(Item_Options) _nc_retrace_item_opts (Item_Options);
-extern NCURSES_EXPORT(MENU *)	    _nc_retrace_menu (MENU *);
-extern NCURSES_EXPORT(Menu_Hook)    _nc_retrace_menu_hook (Menu_Hook);
-extern NCURSES_EXPORT(Menu_Options) _nc_retrace_menu_opts (Menu_Options);
+extern NCMENU_EXPORT(ITEM *)	    _nc_retrace_item (ITEM *);
+extern NCMENU_EXPORT(ITEM **)	    _nc_retrace_item_ptr (ITEM **);
+extern NCMENU_EXPORT(Item_Options) _nc_retrace_item_opts (Item_Options);
+extern NCMENU_EXPORT(MENU *)	    _nc_retrace_menu (MENU *);
+extern NCMENU_EXPORT(Menu_Hook)    _nc_retrace_menu_hook (Menu_Hook);
+extern NCMENU_EXPORT(Menu_Options) _nc_retrace_menu_opts (Menu_Options);
 
 #else /* !TRACE */
 
diff -ur ncurses-5.9-orig/mk-1st.awk ncurses-5.9/mk-1st.awk
--- ncurses-5.9-orig/mk-1st.awk	2010-08-07 16:42:30 -0400
+++ ncurses-5.9/mk-1st.awk	2013-07-04 18:38:38 -0400
@@ -396,11 +396,11 @@
 				end_name = lib_name;
 				printf "../lib/%s : $(%s_OBJS)\n", lib_name, OBJS
 				if ( is_ticlib() ) {
-					printf "\tcd ../lib && $(LIBTOOL_LINK) $(%s) -o %s $(%s_OBJS:$o=.lo) -rpath $(DESTDIR)$(libdir) %s $(NCURSES_MAJOR):$(NCURSES_MINOR) $(LT_UNDEF) $(TICS_LIST)\n", compile, lib_name, OBJS, libtool_version
+					printf "\tcd ../lib && $(LIBTOOL_LINK) $(%s) -shared -o %s $(%s_OBJS:$o=.lo) -rpath $(DESTDIR)$(libdir) %s $(NCURSES_MAJOR):$(NCURSES_MINOR) $(LT_UNDEF) $(TICS_LIST)\n", compile, lib_name, OBJS, libtool_version
 				} else if ( is_termlib() ) {
-					printf "\tcd ../lib && $(LIBTOOL_LINK) $(%s) -o %s $(%s_OBJS:$o=.lo) -rpath $(DESTDIR)$(libdir) %s $(NCURSES_MAJOR):$(NCURSES_MINOR) $(LT_UNDEF) $(TINFO_LIST)\n", compile, lib_name, OBJS, libtool_version
+					printf "\tcd ../lib && $(LIBTOOL_LINK) $(%s) -shared -o %s $(%s_OBJS:$o=.lo) -rpath $(DESTDIR)$(libdir) %s $(NCURSES_MAJOR):$(NCURSES_MINOR) $(LT_UNDEF) $(TINFO_LIST)\n", compile, lib_name, OBJS, libtool_version
 				} else {
-					printf "\tcd ../lib && $(LIBTOOL_LINK) $(%s) -o %s $(%s_OBJS:$o=.lo) -rpath $(DESTDIR)$(libdir) %s $(NCURSES_MAJOR):$(NCURSES_MINOR) $(LT_UNDEF) $(SHLIB_LIST)\n", compile, lib_name, OBJS, libtool_version
+					printf "\tcd ../lib && $(LIBTOOL_LINK) $(%s) -shared -o %s $(%s_OBJS:$o=.lo) -rpath $(DESTDIR)$(libdir) %s $(NCURSES_MAJOR):$(NCURSES_MINOR) $(LT_UNDEF) $(SHLIB_LIST)\n", compile, lib_name, OBJS, libtool_version
 				}
 				print  ""
 				print  "install \\"
diff -ur ncurses-5.9-orig/mk-2nd.awk ncurses-5.9/mk-2nd.awk
--- ncurses-5.9-orig/mk-2nd.awk	2005-01-22 11:30:04 -0500
+++ ncurses-5.9/mk-2nd.awk	2013-07-04 18:38:38 -0400
@@ -122,7 +122,7 @@
 				} else if ( subset ~ /termlib/ ) {
 					mycflags=" -DUSE_TERMLIB"
 				}
-				printf "$(LIBTOOL_COMPILE) $(%s) $(CFLAGS_%s)%s -c ", compile, MODEL, mycflags
+				printf "$(LIBTOOL_COMPILE) $(%s) -shared $(CFLAGS_%s)%s -c ", compile, MODEL, mycflags
 				if ( $3 == "." || srcdir == "." ) {
 					dir = $3 "/"
 					sub("^\\$\\(srcdir\\)/","",dir);
diff -ur ncurses-5.9-orig/ncurses/base/MKlib_gen.sh ncurses-5.9/ncurses/base/MKlib_gen.sh
--- ncurses-5.9-orig/ncurses/base/MKlib_gen.sh	2011-01-22 14:47:29 -0500
+++ ncurses-5.9/ncurses/base/MKlib_gen.sh	2013-07-04 18:38:38 -0400
@@ -159,7 +159,7 @@
 
 if test "$USE" = generated ; then
 cat >$ED4 <<EOF
-	s/^\(.*\) \(.*\) (\(.*\))\$/NCURSES_EXPORT(\1) (\2) (\3)/
+	s/^\(.*\) \(.*\) (\(.*\))\$/NCURSES_EXPORT(\1) \2 (\3)/
 EOF
 else
 cat >$ED4 <<EOF
@@ -224,6 +224,7 @@
 			break;
 		}
 	}
+	printf "UNDEF %s\n", $myfunc;
 	print $0;
 	print "{";
 	argcount = 1;
@@ -451,4 +452,5 @@
 	-e 's/^[ 	]*#/#/' \
 	-e '/#ident/d' \
 	-e '/#line/d' \
+	-e 's/UNDEF/#undef/' \
 | sed -f $ED4
diff -ur ncurses-5.9-orig/ncurses/base/lib_driver.c ncurses-5.9/ncurses/base/lib_driver.c
--- ncurses-5.9-orig/ncurses/base/lib_driver.c	2010-12-19 19:29:17 -0500
+++ ncurses-5.9/ncurses/base/lib_driver.c	2013-07-04 18:38:38 -0400
@@ -42,7 +42,7 @@
 
 static DRIVER_ENTRY DriverTable[] =
 {
-#ifdef __MINGW32__
+#if defined(__MINGW32__) || defined(_MSC_VER)
     {"win", &_nc_WIN_DRIVER},
 #endif
     {"tinfo", &_nc_TINFO_DRIVER}
diff -ur ncurses-5.9-orig/ncurses/curses.priv.h ncurses-5.9/ncurses/curses.priv.h
--- ncurses-5.9-orig/ncurses/curses.priv.h	2011-01-22 16:10:19 -0500
+++ ncurses-5.9/ncurses/curses.priv.h	2013-07-04 18:38:38 -0400
@@ -1239,8 +1239,14 @@
 #define	W_OK	2		/* Test for write permission.  */
 #endif
 #ifndef X_OK
+#ifdef _MSC_VER
+#define X_OK    0		/* MSVC does not support X_OK and generate invalid
+                                 * parameter exception if used as argument to "access"
+                                 * function. */
+#else
 #define	X_OK	1		/* Test for execute permission.  */
 #endif
+#endif
 #ifndef F_OK
 #define	F_OK	0		/* Test for existence.  */
 #endif
@@ -1966,7 +1972,7 @@
  * Not everyone has vsscanf(), but we'd like to use it for scanw().
  */
 #if !HAVE_VSSCANF
-extern int vsscanf(const char *str, const char *format, va_list __arg);
+extern NCURSES_EXPORT(int) vsscanf(const char *str, const char *format, va_list __arg);
 #endif
 
 /* scroll indices */
@@ -2192,7 +2198,7 @@
 #endif /* !USE_TERM_DRIVER */
 
 #ifdef USE_TERM_DRIVER
-#ifdef __MINGW32__
+#if defined(__MINGW32__) || defined(_MSC_VER)
 #include <nc_mingw.h>
 extern NCURSES_EXPORT_VAR(TERM_DRIVER) _nc_WIN_DRIVER;
 #endif
diff -ur ncurses-5.9-orig/ncurses/tinfo/comp_parse.c ncurses-5.9/ncurses/tinfo/comp_parse.c
--- ncurses-5.9-orig/ncurses/tinfo/comp_parse.c	2010-12-25 18:06:37 -0500
+++ ncurses-5.9/ncurses/tinfo/comp_parse.c	2013-07-04 18:38:38 -0400
@@ -55,11 +55,11 @@
 MODULE_ID("$Id: comp_parse.c,v 1.73 2010/12/25 23:06:37 tom Exp $")
 
 static void sanity_check2(TERMTYPE *, bool);
-NCURSES_IMPEXP void NCURSES_API(*_nc_check_termtype2) (TERMTYPE *, bool) = sanity_check2;
+NCURSES_IMPEXP void (NCURSES_API *_nc_check_termtype2) (TERMTYPE *, bool) = sanity_check2;
 
 /* obsolete: 20040705 */
 static void sanity_check(TERMTYPE *);
-NCURSES_IMPEXP void NCURSES_API(*_nc_check_termtype) (TERMTYPE *) = sanity_check;
+NCURSES_IMPEXP void (NCURSES_API *_nc_check_termtype) (TERMTYPE *) = sanity_check;
 
 static void
 enqueue(ENTRY * ep)
diff -ur ncurses-5.9-orig/ncurses/tinfo/db_iterator.c ncurses-5.9/ncurses/tinfo/db_iterator.c
--- ncurses-5.9-orig/ncurses/tinfo/db_iterator.c	2010-12-25 18:00:25 -0500
+++ ncurses-5.9/ncurses/tinfo/db_iterator.c	2013-07-04 18:38:38 -0400
@@ -160,6 +160,11 @@
 		    result = _nc_tic_dir(envp);
 	    }
 	    break;
+#ifdef _MSC_VER
+        case dbdWin32:
+            result = _nc_win32_terminfo();
+            break;
+#endif 
 	case dbdHome:
 	    if (use_terminfo_vars()) {
 		result = _nc_home_terminfo();
diff -ur ncurses-5.9-orig/ncurses/tinfo/home_terminfo.c ncurses-5.9/ncurses/tinfo/home_terminfo.c
--- ncurses-5.9-orig/ncurses/tinfo/home_terminfo.c	2010-12-25 18:43:58 -0500
+++ ncurses-5.9/ncurses/tinfo/home_terminfo.c	2013-07-04 18:38:38 -0400
@@ -37,6 +37,12 @@
 #include <curses.priv.h>
 #include <tic.h>
 
+#ifdef _MSC_VER
+#  include <windows.h>
+#  include <sys/types.h>
+#  include <sys/stat.h>
+#endif
+
 MODULE_ID("$Id: home_terminfo.c,v 1.12 2010/12/25 23:43:58 tom Exp $")
 
 /* ncurses extension...fall back on user's private directory */
@@ -65,3 +71,58 @@
 #endif
     return result;
 }
+
+#ifdef _MSC_VER
+NCURSES_EXPORT(char *)
+_nc_win32_terminfo(void)
+{
+    char *result = NULL;
+    static char *temp = NULL;
+    int n = 1024, nr;
+
+    if (temp == NULL) {
+        HMODULE hmod;
+
+        if (GetModuleHandleEx(GET_MODULE_HANDLE_EX_FLAG_FROM_ADDRESS,
+                              (LPCTSTR)_nc_win32_terminfo,
+                              &hmod)) {
+            do {
+                if (temp == NULL)
+                    temp = typeMalloc(char, n);
+                else {
+                    n *= 2;
+                    temp = typeRealloc(char, n, temp);
+                }
+
+                if ((nr = GetModuleFileName(hmod, temp, n)) == 0)
+                    break;
+                else if (nr < n) {
+                    char *p = strrchr(temp, '\\');
+
+                    if (p != 0) {
+                        *p = 0;
+                        nr = strlen(temp);
+                        if (nr > 4 && strncmp(&temp[nr-4], "\\bin", 4) == 0) {
+                            struct stat st;
+
+                            temp = typeRealloc(char, nr-4+64, temp);
+                            strcpy(&temp[nr-4], "\\share\\terminfo");
+                            if (stat(temp, &st) == 0 && (st.st_mode & _S_IFDIR) != 0)
+                                result = temp;
+                        }
+                    }
+                    break;
+                }
+            } while (1);
+        }
+    } else
+        result = temp;
+
+    if (result == NULL && temp != NULL) {
+        free(temp);
+        temp = NULL;
+    }
+
+    return result;
+}
+#endif
diff -ur ncurses-5.9-orig/ncurses/tinfo/lib_print.c ncurses-5.9/ncurses/tinfo/lib_print.c
--- ncurses-5.9-orig/ncurses/tinfo/lib_print.c	2010-06-05 18:18:35 -0400
+++ ncurses-5.9/ncurses/tinfo/lib_print.c	2013-07-04 18:38:38 -0400
@@ -95,7 +95,7 @@
      * kernel will ship the contiguous clist items from the last write
      * immediately.
      */
-#ifndef __MINGW32__
+#if !defined(__MINGW32__) && !defined(_MSC_VER)
     (void) sleep(0);
 #endif
     free(mybuf);
